// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S034_DetachedSections.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S034_DetachedSections extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int detachedState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\34\u0200\1\u0300\1\u0200\1\u0400\1\u0500\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\1\0\1\4\3\0\1\5\7\0\1\6\1\7\12\10"+
    "\1\11\1\12\5\0\1\13\1\14\1\15\1\16\1\17"+
    "\1\20\1\21\1\22\1\23\1\22\1\24\1\25\1\26"+
    "\1\27\1\30\1\31\1\22\1\32\1\33\1\34\1\35"+
    "\1\22\1\36\1\22\1\37\1\40\1\41\1\0\1\42"+
    "\1\0\1\43\1\0\1\44\1\45\1\46\1\47\1\50"+
    "\1\51\1\52\1\53\1\54\1\53\1\55\1\56\1\57"+
    "\1\60\1\61\1\62\1\53\1\63\1\64\1\65\1\66"+
    "\1\53\1\67\1\53\1\70\1\71\105\0\6\53\1\0"+
    "\11\53\1\0\6\53\2\0\4\53\3\0\6\53\1\0"+
    "\11\53\1\0\6\53\2\0\4\53\53\0\2\53\6\0"+
    "\2\72\66\0\2\53\4\0\2\53\17\0\1\73\u0188\0"+
    "\2\53\216\0\2\53\42\0\2\53\104\0\1\1\u0127\0"+
    "\1\74\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1536];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\4\1\2\2\2\3\24\0\1\4\76\0\1\5"+
    "\56\0\1\6\11\0\1\7\6\0\1\10\15\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[172];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\75\0\172\0\267\0\364\0\u0131\0\u016e\0\u0131"+
    "\0\u01ab\0\u0131\0\u01e8\0\u0225\0\267\0\u0262\0\u029f\0\u02dc"+
    "\0\u0319\0\u0356\0\u0393\0\u03d0\0\u040d\0\u044a\0\u0487\0\u04c4"+
    "\0\u0501\0\u053e\0\u057b\0\u05b8\0\u05f5\0\u0632\0\u066f\0\u0131"+
    "\0\u06ac\0\u06e9\0\u0726\0\u0763\0\u07a0\0\u07dd\0\u081a\0\u0857"+
    "\0\u0894\0\u08d1\0\u090e\0\u094b\0\u0988\0\u09c5\0\u0a02\0\u0a3f"+
    "\0\u0a7c\0\u0ab9\0\u0af6\0\u0b33\0\u0b70\0\u0bad\0\u0bea\0\u0c27"+
    "\0\u0c64\0\u0ca1\0\u0cde\0\u0d1b\0\u0d58\0\u0d95\0\u0dd2\0\u0e0f"+
    "\0\u0e4c\0\u0e89\0\u0ec6\0\u0f03\0\u0f40\0\u0f7d\0\u0fba\0\u0ff7"+
    "\0\u1034\0\u1071\0\u10ae\0\u10eb\0\u1128\0\u1165\0\u11a2\0\u11df"+
    "\0\u121c\0\u1259\0\u1296\0\u12d3\0\u1310\0\u134d\0\u138a\0\u13c7"+
    "\0\u1404\0\u1441\0\u147e\0\u14bb\0\u14f8\0\u1535\0\u0131\0\u1572"+
    "\0\u15af\0\u15ec\0\u1629\0\u1666\0\u16a3\0\u16e0\0\u171d\0\u175a"+
    "\0\u1797\0\u17d4\0\u1811\0\u184e\0\u188b\0\u18c8\0\u1905\0\u1942"+
    "\0\u197f\0\u19bc\0\u19f9\0\u1a36\0\u1a73\0\u1ab0\0\u1aed\0\u1b2a"+
    "\0\u1b67\0\u1ba4\0\u1be1\0\u1c1e\0\u1c5b\0\u1c98\0\u1cd5\0\u1d12"+
    "\0\u1d4f\0\u1d8c\0\u1dc9\0\u1e06\0\u1e43\0\u1e80\0\u1ebd\0\u1efa"+
    "\0\u1f37\0\u1f74\0\u1fb1\0\u1fee\0\u202b\0\u0131\0\u2068\0\u20a5"+
    "\0\u20e2\0\u211f\0\u215c\0\u2199\0\u21d6\0\u2213\0\u2250\0\u0131"+
    "\0\u228d\0\u22ca\0\u2307\0\u2344\0\u2381\0\u23be\0\u0131\0\u23fb"+
    "\0\u2438\0\u2475\0\u24b2\0\u24ef\0\u252c\0\u2569\0\u25a6\0\u25e3"+
    "\0\u2620\0\u265d\0\u269a\0\u26d7";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[172];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\4\1\5\4\4\1\6\2\4\26\6\1\7\2\4"+
    "\26\6\3\4\41\10\1\11\33\10\41\12\1\13\33\12"+
    "\33\0\1\14\30\0\1\14\6\0\1\14\3\0\1\15"+
    "\30\0\1\14\30\0\1\14\6\0\1\14\123\0\1\16"+
    "\5\0\1\14\22\0\1\16\5\0\1\14\6\0\1\14"+
    "\10\0\1\17\112\0\1\20\30\0\1\20\35\0\1\21"+
    "\30\0\1\21\50\0\1\22\30\0\1\22\16\0\1\22"+
    "\25\0\1\23\30\0\1\23\42\0\1\24\30\0\1\24"+
    "\16\0\1\24\40\0\1\25\30\0\1\25\32\0\1\26"+
    "\30\0\1\26\40\0\1\27\30\0\1\27\16\0\1\27"+
    "\27\0\1\30\30\0\1\30\15\0\3\31\1\0\1\32"+
    "\1\31\7\0\1\33\4\0\1\34\7\0\1\35\5\0"+
    "\1\36\5\0\1\33\4\0\1\34\7\0\1\35\5\0"+
    "\1\34\1\35\12\0\1\37\112\0\1\40\30\0\1\40"+
    "\25\0\1\41\64\0\3\31\1\0\1\32\10\0\1\33"+
    "\14\0\1\35\5\0\1\36\5\0\1\33\14\0\1\35"+
    "\6\0\1\35\30\0\1\42\30\0\1\42\37\0\1\43"+
    "\30\0\1\43\15\0\1\43\32\0\1\44\30\0\1\44"+
    "\47\0\1\45\30\0\1\45\34\0\1\46\30\0\1\46"+
    "\31\0\26\47\2\0\1\47\44\0\2\50\1\51\10\50"+
    "\1\52\3\50\1\53\6\50\2\0\1\50\2\0\1\54"+
    "\10\0\1\55\3\0\1\56\25\0\1\57\30\0\1\57"+
    "\62\0\1\60\30\0\1\60\6\0\1\60\30\0\1\61"+
    "\30\0\1\61\27\0\1\62\30\0\1\62\54\0\1\63"+
    "\30\0\1\63\16\0\1\63\11\0\1\64\1\0\26\47"+
    "\2\0\1\47\42\0\1\65\1\0\26\50\2\0\1\50"+
    "\42\0\1\65\1\0\10\50\1\66\4\50\1\67\10\50"+
    "\2\0\1\50\10\0\1\70\4\0\1\71\10\0\1\70"+
    "\13\0\1\65\1\0\22\50\1\72\3\50\2\0\1\50"+
    "\22\0\1\73\17\0\1\65\1\0\4\50\1\74\21\50"+
    "\2\0\1\50\4\0\1\75\47\0\1\70\4\0\1\71"+
    "\23\0\1\70\4\0\1\71\10\0\1\70\37\0\1\73"+
    "\30\0\1\73\25\0\1\75\30\0\1\75\57\0\1\76"+
    "\30\0\1\76\6\0\1\76\35\0\1\77\30\0\1\77"+
    "\26\0\1\31\3\0\1\31\24\0\1\31\3\0\1\31"+
    "\15\0\1\31\17\0\1\100\30\0\1\100\55\0\1\101"+
    "\30\0\1\101\14\0\2\64\3\0\4\64\1\102\27\64"+
    "\2\0\32\64\2\65\3\0\4\65\1\103\27\65\2\0"+
    "\32\65\11\0\1\65\1\0\21\50\1\104\4\50\2\0"+
    "\1\50\21\0\1\105\20\0\1\65\1\0\22\50\1\106"+
    "\3\50\2\0\1\50\22\0\1\107\42\0\1\105\30\0"+
    "\1\105\44\0\1\107\30\0\1\107\17\0\1\65\1\0"+
    "\14\50\1\110\11\50\2\0\1\50\14\0\1\111\43\0"+
    "\1\111\30\0\1\111\25\0\1\65\1\0\6\50\1\112"+
    "\17\50\2\0\1\50\6\0\1\113\43\0\1\113\30\0"+
    "\1\113\53\0\1\114\30\0\1\114\13\0\3\115\1\0"+
    "\1\116\1\115\4\0\1\62\25\0\1\36\2\0\1\62"+
    "\45\0\1\117\30\0\1\117\37\0\1\120\73\0\1\121"+
    "\74\0\1\122\75\0\1\65\1\0\24\50\1\123\1\50"+
    "\2\0\1\50\24\0\1\124\43\0\1\124\30\0\1\124"+
    "\15\0\1\65\1\0\14\50\1\125\11\50\2\0\1\50"+
    "\14\0\1\126\43\0\1\126\30\0\1\126\25\0\1\65"+
    "\1\0\10\50\1\127\15\50\2\0\1\50\10\0\1\130"+
    "\15\0\1\130\25\0\1\130\30\0\1\130\15\0\1\130"+
    "\13\0\1\65\1\0\10\50\1\131\15\50\2\0\1\50"+
    "\10\0\1\132\15\0\1\132\25\0\1\132\30\0\1\132"+
    "\15\0\1\132\14\0\1\31\63\0\3\115\1\0\1\116"+
    "\33\0\1\36\62\0\1\133\30\0\1\133\27\0\1\134"+
    "\30\0\1\134\45\0\1\135\15\0\1\136\12\0\1\135"+
    "\15\0\1\136\6\0\1\136\11\0\1\121\31\0\1\137"+
    "\42\0\1\122\31\0\1\140\43\0\1\141\1\0\26\50"+
    "\2\0\1\50\42\0\1\141\74\0\1\65\1\0\21\50"+
    "\1\142\4\50\2\0\1\50\21\0\1\143\43\0\1\143"+
    "\30\0\1\143\20\0\1\65\1\0\2\50\1\144\23\50"+
    "\2\0\1\50\2\0\1\145\43\0\1\145\30\0\1\145"+
    "\37\0\1\65\1\0\15\50\1\146\10\50\2\0\1\50"+
    "\15\0\1\147\43\0\1\147\30\0\1\147\27\0\1\150"+
    "\30\0\1\150\63\0\1\151\30\0\1\151\32\0\1\152"+
    "\30\0\1\152\15\0\1\152\36\0\1\153\30\0\1\153"+
    "\7\0\41\154\1\0\33\154\2\141\3\0\4\141\1\155"+
    "\27\141\2\0\32\141\11\0\1\65\1\0\17\50\1\104"+
    "\6\50\2\0\1\50\17\0\1\105\43\0\1\105\30\0"+
    "\1\105\22\0\1\65\1\0\10\50\1\156\15\50\2\0"+
    "\1\50\10\0\1\157\15\0\1\157\25\0\1\157\30\0"+
    "\1\157\15\0\1\157\13\0\1\65\1\0\14\50\1\123"+
    "\11\50\2\0\1\50\14\0\1\124\43\0\1\124\30\0"+
    "\1\124\47\0\1\160\30\0\1\160\6\0\1\160\45\0"+
    "\1\115\3\0\1\115\3\0\1\115\4\0\1\115\47\0"+
    "\1\161\30\0\1\161\40\0\1\162\30\0\1\162\12\0"+
    "\41\154\1\163\33\154\10\0\1\164\75\0\1\65\1\0"+
    "\16\50\1\165\7\50\2\0\1\50\16\0\1\166\43\0"+
    "\1\166\30\0\1\166\43\0\1\167\30\0\1\167\51\0"+
    "\1\170\30\0\1\170\42\0\1\171\30\0\1\171\14\0"+
    "\1\172\75\0\1\164\31\0\1\173\43\0\1\65\1\0"+
    "\1\174\25\50\2\0\1\50\1\175\43\0\1\175\30\0"+
    "\1\175\42\0\1\115\73\0\1\176\74\0\1\177\110\0"+
    "\1\200\30\0\1\200\16\0\41\201\1\0\33\201\11\0"+
    "\1\65\1\0\12\50\1\202\13\50\2\0\1\50\12\0"+
    "\1\203\43\0\1\203\30\0\1\203\16\0\2\176\3\0"+
    "\4\176\1\204\27\176\2\0\32\176\30\0\1\205\30\0"+
    "\1\205\37\0\1\206\30\0\1\206\16\0\1\206\41\201"+
    "\1\207\33\201\11\0\1\65\1\0\10\50\1\66\15\50"+
    "\2\0\1\50\10\0\1\70\15\0\1\70\25\0\1\70"+
    "\30\0\1\70\15\0\1\70\12\0\1\210\104\0\1\211"+
    "\30\0\1\211\52\0\1\212\30\0\1\212\23\0\1\213"+
    "\75\0\1\210\31\0\1\214\43\0\1\215\125\0\1\216"+
    "\57\0\1\217\30\0\1\217\16\0\41\220\1\0\33\220"+
    "\10\0\1\221\110\0\1\222\30\0\1\222\16\0\1\222"+
    "\41\220\1\223\33\220\10\0\1\221\31\0\1\224\61\0"+
    "\1\225\30\0\1\225\23\0\1\226\65\0\41\227\1\0"+
    "\33\227\42\0\1\230\57\0\1\231\30\0\1\231\16\0"+
    "\41\227\1\232\33\227\24\0\1\233\30\0\1\233\16\0"+
    "\1\233\7\0\1\234\114\0\1\235\30\0\1\235\41\0"+
    "\1\236\30\0\1\236\60\0\1\237\56\0\1\240\30\0"+
    "\1\240\16\0\1\240\27\0\1\241\30\0\1\241\56\0"+
    "\1\242\33\0\3\242\1\0\1\243\33\0\1\244\62\0"+
    "\1\245\30\0\1\245\41\0\1\246\30\0\1\246\32\0"+
    "\1\247\30\0\1\247\53\0\1\250\30\0\1\250\16\0"+
    "\1\250\33\0\1\251\30\0\1\251\6\0\1\251\30\0"+
    "\1\252\30\0\1\252\45\0\1\253\30\0\1\253\23\0"+
    "\1\254\75\0\1\242\77\0\1\135\30\0\1\135\26\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[10004];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\2\1\1\11\1\1\1\11\1\1\1\11\1\1"+
    "\24\0\1\11\76\0\1\11\56\0\1\11\11\0\1\11"+
    "\6\0\1\11\15\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[172];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S034_DetachedSections() { }



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S034_DetachedSections(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 9: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 10: break;
          case 3:
            { checkEnd();
            }
          // fall through
          case 11: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 12: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 13: break;
          case 6:
            { if( !checkEdge()) {
		
			AnnotationEntity retrievedEntity = retrieveEntity();
			
			offset += yylength();
			position += retrievedEntity.getText().length();
		}
            }
          // fall through
          case 14: break;
          case 7:
            { offset += yylength();
		
		AnnotationEntity retrievedEntity = retrieveEntity();
		
		annotationEntity.addRelatedEntity(retrievedEntity);
		retrievedEntity.addRelatedEntity(annotationEntity);
		
		position += retrievedEntity.getText().length();
            }
          // fall through
          case 15: break;
          case 8:
            { start(new AnnotationEntity(Entity.CL_DETACHED), detachedState, true, false);
            }
          // fall through
          case 16: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S034_DetachedSections [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S034_DetachedSections scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S034_DetachedSections(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
